diff --git a/tests/unit/modules/test_virt.py b/tests/unit/modules/test_virt.py
index fbc03cf7a6..1a9b17699b 100644
--- a/tests/unit/modules/test_virt.py
+++ b/tests/unit/modules/test_virt.py
@@ -460,109 +580,493 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
         self.assertEqual(root.find("devices/graphics/listen").attrib["type"], "none")
         self.assertFalse("address" in root.find("devices/graphics/listen").attrib)
 
-    def test_default_disk_profile_hypervisor_esxi(self):
+    def test_gen_xml_memory(self):
         """
-        Test virt._disk_profile() default ESXi profile
+        Test virt._gen_xml() with advanced memory settings
         """
-        mock = MagicMock(return_value={})
-        with patch.dict(
-            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
-        ):
-            ret = virt._disk_profile(
-                self.mock_conn, "nonexistent", "vmware", None, "test-vm"
-            )
-            self.assertTrue(len(ret) == 1)
-            found = [disk for disk in ret if disk["name"] == "system"]
-            self.assertTrue(bool(found))
-            system = found[0]
-            self.assertEqual(system["format"], "vmdk")
-            self.assertEqual(system["model"], "scsi")
-            self.assertTrue(int(system["size"]) >= 1)
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
+        xml_data = virt._gen_xml(
+            self.mock_conn,
+            "hello",
+            1,
+            {
+                "boot": "512m",
+                "current": "256m",
+                "max": "1g",
+                "hard_limit": "1024",
+                "soft_limit": "512m",
+                "swap_hard_limit": "1g",
+                "min_guarantee": "256m",
+                "hugepages": [
+                    {"nodeset": "", "size": "128m"},
+                    {"nodeset": "0", "size": "256m"},
+                    {"nodeset": "1", "size": "512m"},
+                ],
+                "nosharepages": True,
+                "locked": True,
+                "source": "file",
+                "access": "shared",
+                "allocation": "immediate",
+                "discard": True,
+            },
+            diskp,
+            nicp,
+            "kvm",
+            "hvm",
+            "x86_64",
+        )
+        root = ET.fromstring(xml_data)
+        self.assertEqualUnit(root.find("memory"), 512 * 1024)
+        self.assertEqualUnit(root.find("currentMemory"), 256 * 1024)
+        self.assertEqualUnit(root.find("maxMemory"), 1024 * 1024)
+        self.assertFalse("slots" in root.find("maxMemory").keys())
+        self.assertEqualUnit(root.find("memtune/hard_limit"), 1024 * 1024)
+        self.assertEqualUnit(root.find("memtune/soft_limit"), 512 * 1024)
+        self.assertEqualUnit(root.find("memtune/swap_hard_limit"), 1024 ** 2)
+        self.assertEqualUnit(root.find("memtune/min_guarantee"), 256 * 1024)
+        self.assertEqual(
+            [
+                {"nodeset": page.get("nodeset"), "size": page.get("size")}
+                for page in root.findall("memoryBacking/hugepages/page")
+            ],
+            [
+                {"nodeset": None, "size": str(128 * 1024)},
+                {"nodeset": "0", "size": str(256 * 1024)},
+                {"nodeset": "1", "size": str(512 * 1024)},
+            ],
+        )
+        self.assertIsNotNone(root.find("memoryBacking/nosharepages"))
+        self.assertIsNotNone(root.find("memoryBacking/locked"))
+        self.assertIsNotNone(root.find("memoryBacking/discard"))
+        self.assertEqual(root.find("memoryBacking/source").get("type"), "file")
+        self.assertEqual(root.find("memoryBacking/access").get("mode"), "shared")
+        self.assertEqual(root.find("memoryBacking/allocation").get("mode"), "immediate")
 
-    def test_default_disk_profile_hypervisor_kvm(self):
+    def test_gen_xml_cpu(self):
         """
-        Test virt._disk_profile() default KVM profile
+        Test virt._gen_xml() with CPU advanced properties
         """
-        mock = MagicMock(side_effect=[{}, "/images/dir"])
-        with patch.dict(
-            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
-        ):
-            ret = virt._disk_profile(
-                self.mock_conn, "nonexistent", "kvm", None, "test-vm"
-            )
-            self.assertTrue(len(ret) == 1)
-            found = [disk for disk in ret if disk["name"] == "system"]
-            self.assertTrue(bool(found))
-            system = found[0]
-            self.assertEqual(system["format"], "qcow2")
-            self.assertEqual(system["model"], "virtio")
-            self.assertTrue(int(system["size"]) >= 1)
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
+        xml_data = virt._gen_xml(
+            self.mock_conn,
+            "hello",
+            {
+                "maximum": 12,
+                "placement": "static",
+                "cpuset": "0-11",
+                "current": 5,
+                "mode": "custom",
+                "match": "minimum",
+                "check": "full",
+                "vendor": "Intel",
+                "model": {
+                    "name": "core2duo",
+                    "fallback": "allow",
+                    "vendor_id": "GenuineIntel",
+                },
+                "cache": {"level": 3, "mode": "emulate"},
+                "features": {"lahf": "optional", "vmx": "require"},
+                "vcpus": {
+                    0: {"enabled": True, "hotpluggable": True},
+                    1: {"enabled": False},
+                },
+            },
+            512,
+            diskp,
+            nicp,
+            "kvm",
+            "hvm",
+            "x86_64",
+        )
+        root = ET.fromstring(xml_data)
+        self.assertEqual(root.find("vcpu").get("current"), "5")
+        self.assertEqual(root.find("vcpu").get("placement"), "static")
+        self.assertEqual(root.find("vcpu").get("cpuset"), "0-11")
+        self.assertEqual(root.find("vcpu").text, "12")
+        self.assertEqual(root.find("cpu").get("match"), "minimum")
+        self.assertEqual(root.find("cpu").get("mode"), "custom")
+        self.assertEqual(root.find("cpu").get("check"), "full")
+        self.assertEqual(root.find("cpu/vendor").text, "Intel")
+        self.assertEqual(root.find("cpu/model").text, "core2duo")
+        self.assertEqual(root.find("cpu/model").get("fallback"), "allow")
+        self.assertEqual(root.find("cpu/model").get("vendor_id"), "GenuineIntel")
+        self.assertEqual(root.find("cpu/cache").get("level"), "3")
+        self.assertEqual(root.find("cpu/cache").get("mode"), "emulate")
+        self.assertEqual(
+            {f.get("name"): f.get("policy") for f in root.findall("cpu/feature")},
+            {"lahf": "optional", "vmx": "require"},
+        )
+        self.assertEqual(
+            {
+                v.get("id"): {
+                    "enabled": v.get("enabled"),
+                    "hotpluggable": v.get("hotpluggable"),
+                }
+                for v in root.findall("vcpus/vcpu")
+            },
+            {
+                "0": {"enabled": "yes", "hotpluggable": "yes"},
+                "1": {"enabled": "no", "hotpluggable": None},
+            },
+        )
 
-    def test_default_disk_profile_hypervisor_xen(self):
+    def test_gen_xml_cpu_topology(self):
         """
-        Test virt._disk_profile() default XEN profile
+        Test virt._gen_xml() with CPU topology
         """
-        mock = MagicMock(side_effect=[{}, "/images/dir"])
-        with patch.dict(
-            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
-        ):
-            ret = virt._disk_profile(
-                self.mock_conn, "nonexistent", "xen", None, "test-vm"
-            )
-            self.assertTrue(len(ret) == 1)
-            found = [disk for disk in ret if disk["name"] == "system"]
-            self.assertTrue(bool(found))
-            system = found[0]
-            self.assertEqual(system["format"], "qcow2")
-            self.assertEqual(system["model"], "xen")
-            self.assertTrue(int(system["size"]) >= 1)
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
+        xml_data = virt._gen_xml(
+            self.mock_conn,
+            "hello",
+            {"maximum": 1, "topology": {"sockets": 4, "cores": 16, "threads": 2}},
+            512,
+            diskp,
+            nicp,
+            "kvm",
+            "hvm",
+            "x86_64",
+        )
+        root = ET.fromstring(xml_data)
+        self.assertEqual(root.find("cpu/topology").get("sockets"), "4")
+        self.assertEqual(root.find("cpu/topology").get("cores"), "16")
+        self.assertEqual(root.find("cpu/topology").get("threads"), "2")
 
-    def test_default_nic_profile_hypervisor_esxi(self):
+    def test_gen_xml_cpu_numa(self):
         """
-        Test virt._nic_profile() default ESXi profile
+        Test virt._gen_xml() with CPU numa settings
         """
-        mock = MagicMock(return_value={})
-        with patch.dict(
-            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
-        ):
-            ret = virt._nic_profile("nonexistent", "vmware")
-            self.assertTrue(len(ret) == 1)
-            eth0 = ret[0]
-            self.assertEqual(eth0["name"], "eth0")
-            self.assertEqual(eth0["type"], "bridge")
-            self.assertEqual(eth0["source"], "DEFAULT")
-            self.assertEqual(eth0["model"], "e1000")
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
+        xml_data = virt._gen_xml(
+            self.mock_conn,
+            "hello",
+            {
+                "maximum": 1,
+                "numa": {
+                    0: {
+                        "cpus": "0-3",
+                        "memory": "1g",
+                        "discard": True,
+                        "distances": {0: 10, 1: 20},
+                    },
+                    1: {"cpus": "4-7", "memory": "2g", "distances": {0: 20, 1: 10}},
+                },
+            },
+            512,
+            diskp,
+            nicp,
+            "kvm",
+            "hvm",
+            "x86_64",
+        )
+        root = ET.fromstring(xml_data)
+        cell0 = root.find("cpu/numa/cell[@id='0']")
+        self.assertEqual(cell0.get("cpus"), "0-3")
+        self.assertIsNone(cell0.get("unit"))
+        self.assertEqual(cell0.get("memory"), str(1024 ** 2))
+        self.assertEqual(cell0.get("discard"), "yes")
+        self.assertEqual(
+            {d.get("id"): d.get("value") for d in cell0.findall("distances/sibling")},
+            {"0": "10", "1": "20"},
+        )
 
-    def test_default_nic_profile_hypervisor_kvm(self):
-        """
-        Test virt._nic_profile() default KVM profile
-        """
-        mock = MagicMock(return_value={})
-        with patch.dict(
-            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
-        ):
-            ret = virt._nic_profile("nonexistent", "kvm")
-            self.assertTrue(len(ret) == 1)
-            eth0 = ret[0]
-            self.assertEqual(eth0["name"], "eth0")
-            self.assertEqual(eth0["type"], "bridge")
-            self.assertEqual(eth0["source"], "br0")
-            self.assertEqual(eth0["model"], "virtio")
+        cell1 = root.find("cpu/numa/cell[@id='1']")
+        self.assertEqual(cell1.get("cpus"), "4-7")
+        self.assertIsNone(cell0.get("unit"))
+        self.assertEqual(cell1.get("memory"), str(2 * 1024 ** 2))
+        self.assertFalse("discard" in cell1.keys())
+        self.assertEqual(
+            {d.get("id"): d.get("value") for d in cell1.findall("distances/sibling")},
+            {"0": "20", "1": "10"},
+        )
 
-    def test_default_nic_profile_hypervisor_xen(self):
+    def test_gen_xml_cputune(self):
         """
-        Test virt._nic_profile() default XEN profile
+        Test virt._gen_xml() with CPU tuning
         """
-        mock = MagicMock(return_value={})
-        with patch.dict(
-            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
-        ):
-            ret = virt._nic_profile("nonexistent", "xen")
-            self.assertTrue(len(ret) == 1)
-            eth0 = ret[0]
-            self.assertEqual(eth0["name"], "eth0")
-            self.assertEqual(eth0["type"], "bridge")
-            self.assertEqual(eth0["source"], "br0")
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
+        cputune = {
+            "shares": 2048,
+            "period": 122000,
+            "quota": -1,
+            "global_period": 1000000,
+            "global_quota": -3,
+            "emulator_period": 1200000,
+            "emulator_quota": -10,
+            "iothread_period": 133000,
+            "iothread_quota": -1,
+            "vcpupin": {0: "1-4,^2", 1: "0,1", 2: "2,3", 3: "0,4"},
+            "emulatorpin": "1-3",
+            "iothreadpin": {1: "5-6", 2: "7-8"},
+            "vcpusched": [
+                {"scheduler": "fifo", "priority": 1, "vcpus": "0"},
+                {"scheduler": "fifo", "priority": 2, "vcpus": "1"},
+                {"scheduler": "idle", "priority": 3, "vcpus": "2"},
+            ],
+            "iothreadsched": [
+                {"scheduler": "idle"},
+                {"scheduler": "batch", "iothreads": "5-7", "priority": 1},
+            ],
+            "emulatorsched": {"scheduler": "rr", "priority": 2},
+            "cachetune": {
+                "0-3": {
+                    0: {"level": 3, "type": "both", "size": 3},
+                    1: {"level": 3, "type": "both", "size": 3},
+                    "monitor": {1: 3, "0-3": 3},
+                },
+                "4-5": {"monitor": {4: 3, 5: 2}},
+            },
+            "memorytune": {"0-2": {0: 60}, "3-4": {0: 50, 1: 70}},
+        }
+        xml_data = virt._gen_xml(
+            self.mock_conn,
+            "hello",
+            {"maximum": 1, "tuning": cputune, "iothreads": 2},
+            512,
+            diskp,
+            nicp,
+            "kvm",
+            "hvm",
+            "x86_64",
+        )
+        root = ET.fromstring(xml_data)
+        self.assertEqual(root.find("cputune").find("shares").text, "2048")
+        self.assertEqual(root.find("cputune").find("period").text, "122000")
+        self.assertEqual(root.find("cputune").find("quota").text, "-1")
+        self.assertEqual(root.find("cputune").find("global_period").text, "1000000")
+        self.assertEqual(root.find("cputune").find("global_quota").text, "-3")
+        self.assertEqual(root.find("cputune").find("emulator_period").text, "1200000")
+        self.assertEqual(root.find("cputune").find("emulator_quota").text, "-10")
+        self.assertEqual(root.find("cputune").find("iothread_period").text, "133000")
+        self.assertEqual(root.find("cputune").find("iothread_quota").text, "-1")
+        self.assertEqual(
+            root.find("cputune").find("vcpupin[@vcpu='0']").attrib.get("cpuset"),
+            "1-4,^2",
+        )
+        self.assertEqual(
+            root.find("cputune").find("vcpupin[@vcpu='1']").attrib.get("cpuset"), "0,1",
+        )
+        self.assertEqual(
+            root.find("cputune").find("vcpupin[@vcpu='2']").attrib.get("cpuset"), "2,3",
+        )
+        self.assertEqual(
+            root.find("cputune").find("vcpupin[@vcpu='3']").attrib.get("cpuset"), "0,4",
+        )
+        self.assertEqual(
+            root.find("cputune").find("emulatorpin").attrib.get("cpuset"), "1-3"
+        )
+        self.assertEqual(
+            root.find("cputune")
+            .find("iothreadpin[@iothread='1']")
+            .attrib.get("cpuset"),
+            "5-6",
+        )
+        self.assertEqual(
+            root.find("cputune")
+            .find("iothreadpin[@iothread='2']")
+            .attrib.get("cpuset"),
+            "7-8",
+        )
+        self.assertDictEqual(
+            {
+                s.get("vcpus"): {
+                    "scheduler": s.get("scheduler"),
+                    "priority": s.get("priority"),
+                }
+                for s in root.findall("cputune/vcpusched")
+            },
+            {
+                "0": {"scheduler": "fifo", "priority": "1"},
+                "1": {"scheduler": "fifo", "priority": "2"},
+                "2": {"scheduler": "idle", "priority": "3"},
+            },
+        )
+        self.assertDictEqual(
+            {
+                s.get("iothreads"): {
+                    "scheduler": s.get("scheduler"),
+                    "priority": s.get("priority"),
+                }
+                for s in root.findall("cputune/iothreadsched")
+            },
+            {
+                None: {"scheduler": "idle", "priority": None},
+                "5-7": {"scheduler": "batch", "priority": "1"},
+            },
+        )
+        self.assertEqual(root.find("cputune/emulatorsched").get("scheduler"), "rr")
+        self.assertEqual(root.find("cputune/emulatorsched").get("priority"), "2")
+        self.assertEqual(
+            root.find("./cputune/cachetune[@vcpus='0-3']").attrib.get("vcpus"), "0-3"
+        )
+        self.assertEqual(
+            root.find("./cputune/cachetune[@vcpus='0-3']/cache[@id='0']").attrib.get(
+                "level"
+            ),
+            "3",
+        )
+        self.assertEqual(
+            root.find("./cputune/cachetune[@vcpus='0-3']/cache[@id='0']").attrib.get(
+                "type"
+            ),
+            "both",
+        )
+        self.assertEqual(
+            root.find(
+                "./cputune/cachetune[@vcpus='0-3']/monitor[@vcpus='1']"
+            ).attrib.get("level"),
+            "3",
+        )
+        self.assertNotEqual(
+            root.find("./cputune/cachetune[@vcpus='0-3']/monitor[@vcpus='1']"), None
+        )
+        self.assertNotEqual(
+            root.find("./cputune/cachetune[@vcpus='4-5']").attrib.get("vcpus"), None
+        )
+        self.assertEqual(
+            root.find("./cputune/cachetune[@vcpus='4-5']/cache[@id='0']"), None
+        )
+        self.assertEqual(
+            root.find(
+                "./cputune/cachetune[@vcpus='4-5']/monitor[@vcpus='4']"
+            ).attrib.get("level"),
+            "3",
+        )
+        self.assertEqual(
+            root.find(
+                "./cputune/cachetune[@vcpus='4-5']/monitor[@vcpus='5']"
+            ).attrib.get("level"),
+            "2",
+        )
+        self.assertNotEqual(root.find("./cputune/memorytune[@vcpus='0-2']"), None)
+        self.assertEqual(
+            root.find("./cputune/memorytune[@vcpus='0-2']/node[@id='0']").attrib.get(
+                "bandwidth"
+            ),
+            "60",
+        )
+        self.assertNotEqual(root.find("./cputune/memorytune[@vcpus='3-4']"), None)
+        self.assertEqual(
+            root.find("./cputune/memorytune[@vcpus='3-4']/node[@id='0']").attrib.get(
+                "bandwidth"
+            ),
+            "50",
+        )
+        self.assertEqual(
+            root.find("./cputune/memorytune[@vcpus='3-4']/node[@id='1']").attrib.get(
+                "bandwidth"
+            ),
+            "70",
+        )
+        self.assertEqual(root.find("iothreads").text, "2")
+
+    def test_default_disk_profile_hypervisor_esxi(self):
+        """
+        Test virt._disk_profile() default ESXi profile
+        """
+        mock = MagicMock(return_value={})
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._disk_profile(
+                self.mock_conn, "nonexistent", "vmware", None, "test-vm"
+            )
+            self.assertTrue(len(ret) == 1)
+            found = [disk for disk in ret if disk["name"] == "system"]
+            self.assertTrue(bool(found))
+            system = found[0]
+            self.assertEqual(system["format"], "vmdk")
+            self.assertEqual(system["model"], "scsi")
+            self.assertTrue(int(system["size"]) >= 1)
+
+    def test_default_disk_profile_hypervisor_kvm(self):
+        """
+        Test virt._disk_profile() default KVM profile
+        """
+        mock = MagicMock(side_effect=[{}, "/images/dir"])
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._disk_profile(
+                self.mock_conn, "nonexistent", "kvm", None, "test-vm"
+            )
+            self.assertTrue(len(ret) == 1)
+            found = [disk for disk in ret if disk["name"] == "system"]
+            self.assertTrue(bool(found))
+            system = found[0]
+            self.assertEqual(system["format"], "qcow2")
+            self.assertEqual(system["model"], "virtio")
+            self.assertTrue(int(system["size"]) >= 1)
+
+    def test_default_disk_profile_hypervisor_xen(self):
+        """
+        Test virt._disk_profile() default XEN profile
+        """
+        mock = MagicMock(side_effect=[{}, "/images/dir"])
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._disk_profile(
+                self.mock_conn, "nonexistent", "xen", None, "test-vm"
+            )
+            self.assertTrue(len(ret) == 1)
+            found = [disk for disk in ret if disk["name"] == "system"]
+            self.assertTrue(bool(found))
+            system = found[0]
+            self.assertEqual(system["format"], "qcow2")
+            self.assertEqual(system["model"], "xen")
+            self.assertTrue(int(system["size"]) >= 1)
+
+    def test_default_nic_profile_hypervisor_esxi(self):
+        """
+        Test virt._nic_profile() default ESXi profile
+        """
+        mock = MagicMock(return_value={})
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._nic_profile("nonexistent", "vmware")
+            self.assertTrue(len(ret) == 1)
+            eth0 = ret[0]
+            self.assertEqual(eth0["name"], "eth0")
+            self.assertEqual(eth0["type"], "bridge")
+            self.assertEqual(eth0["source"], "DEFAULT")
+            self.assertEqual(eth0["model"], "e1000")
+
+    def test_default_nic_profile_hypervisor_kvm(self):
+        """
+        Test virt._nic_profile() default KVM profile
+        """
+        mock = MagicMock(return_value={})
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._nic_profile("nonexistent", "kvm")
+            self.assertTrue(len(ret) == 1)
+            eth0 = ret[0]
+            self.assertEqual(eth0["name"], "eth0")
+            self.assertEqual(eth0["type"], "bridge")
+            self.assertEqual(eth0["source"], "br0")
+            self.assertEqual(eth0["model"], "virtio")
+
+    def test_default_nic_profile_hypervisor_xen(self):
+        """
+        Test virt._nic_profile() default XEN profile
+        """
+        mock = MagicMock(return_value={})
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._nic_profile("nonexistent", "xen")
+            self.assertTrue(len(ret) == 1)
+            eth0 = ret[0]
+            self.assertEqual(eth0["name"], "eth0")
+            self.assertEqual(eth0["type"], "bridge")
+            self.assertEqual(eth0["source"], "br0")
             self.assertFalse(eth0["model"])
 
     def test_gen_vol_xml_esx(self):
@@ -1837,6 +2341,8 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
                   <alias name='video0'/>
                   <address type='pci' domain='0x0000' bus='0x00' slot='0x02' function='0x0'/>
                 </video>
+                <serial type='pty'/>
+                <console type='pty'/>
               </devices>
             </domain>
         """.format(
@@ -1897,10 +2403,11 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
                 username=None,
                 password=None,
                 boot=None,
+                numatune=None,
             ),
         )
 
-        # Update vcpus case
+        # test cpu passed as an integer case
         setvcpus_mock = MagicMock(return_value=0)
         domain_mock.setVcpusFlags = setvcpus_mock
         self.assertEqual(
